xref: /linux/scripts/kconfig/Makefile (revision 3aaefce10351fecab348f5e06857f44cafc61a62)
1# ===========================================================================
2# Kernel configuration targets
3# These targets are used from top-level makefile
4
5PHONY += oldconfig xconfig gconfig menuconfig config silentoldconfig update-po-config \
6	localmodconfig localyesconfig
7
8ifdef KBUILD_KCONFIG
9Kconfig := $(KBUILD_KCONFIG)
10else
11Kconfig := Kconfig
12endif
13
14# We need this, in case the user has it in its environment
15unexport CONFIG_
16
17xconfig: $(obj)/qconf
18	$< $(Kconfig)
19
20gconfig: $(obj)/gconf
21	$< $(Kconfig)
22
23menuconfig: $(obj)/mconf
24	$< $(Kconfig)
25
26config: $(obj)/conf
27	$< --oldaskconfig $(Kconfig)
28
29nconfig: $(obj)/nconf
30	$< $(Kconfig)
31
32oldconfig: $(obj)/conf
33	$< --$@ $(Kconfig)
34
35silentoldconfig: $(obj)/conf
36	$(Q)mkdir -p include/config include/generated
37	$< --$@ $(Kconfig)
38
39localyesconfig localmodconfig: $(obj)/streamline_config.pl $(obj)/conf
40	$(Q)mkdir -p include/config include/generated
41	$(Q)perl $< --$@ $(srctree) $(Kconfig) > .tmp.config
42	$(Q)if [ -f .config ]; then 					\
43			cmp -s .tmp.config .config ||			\
44			(mv -f .config .config.old.1;			\
45			 mv -f .tmp.config .config;			\
46			 $(obj)/conf --silentoldconfig $(Kconfig);	\
47			 mv -f .config.old.1 .config.old)		\
48	else								\
49			mv -f .tmp.config .config;			\
50			$(obj)/conf --silentoldconfig $(Kconfig);	\
51	fi
52	$(Q)rm -f .tmp.config
53
54# Create new linux.pot file
55# Adjust charset to UTF-8 in .po file to accept UTF-8 in Kconfig files
56update-po-config: $(obj)/kxgettext $(obj)/gconf.glade.h
57	$(Q)echo "  GEN     config.pot"
58	$(Q)xgettext --default-domain=linux                         \
59	    --add-comments --keyword=_ --keyword=N_                 \
60	    --from-code=UTF-8                                       \
61	    --files-from=$(srctree)/scripts/kconfig/POTFILES.in     \
62	    --directory=$(srctree) --directory=$(objtree)           \
63	    --output $(obj)/config.pot
64	$(Q)sed -i s/CHARSET/UTF-8/ $(obj)/config.pot
65	$(Q)(for i in `ls $(srctree)/arch/*/Kconfig      \
66	    $(srctree)/arch/*/um/Kconfig`;               \
67	    do                                           \
68		echo "  GEN     $$i";                    \
69		$(obj)/kxgettext $$i                     \
70		     >> $(obj)/config.pot;               \
71	    done )
72	$(Q)echo "  GEN     linux.pot"
73	$(Q)msguniq --sort-by-file --to-code=UTF-8 $(obj)/config.pot \
74	    --output $(obj)/linux.pot
75	$(Q)rm -f $(obj)/config.pot
76
77PHONY += allnoconfig allyesconfig allmodconfig alldefconfig randconfig
78
79allnoconfig allyesconfig allmodconfig alldefconfig randconfig: $(obj)/conf
80	$< --$@ $(Kconfig)
81
82PHONY += listnewconfig olddefconfig oldnoconfig savedefconfig defconfig
83
84listnewconfig olddefconfig: $(obj)/conf
85	$< --$@ $(Kconfig)
86
87# oldnoconfig is an alias of olddefconfig, because people already are dependent
88# on its behavior(sets new symbols to their default value but not 'n') with the
89# counter-intuitive name.
90oldnoconfig: $(obj)/conf
91	$< --olddefconfig $(Kconfig)
92
93savedefconfig: $(obj)/conf
94	$< --$@=defconfig $(Kconfig)
95
96defconfig: $(obj)/conf
97ifeq ($(KBUILD_DEFCONFIG),)
98	$< --defconfig $(Kconfig)
99else
100	@echo "*** Default configuration is based on '$(KBUILD_DEFCONFIG)'"
101	$(Q)$< --defconfig=arch/$(SRCARCH)/configs/$(KBUILD_DEFCONFIG) $(Kconfig)
102endif
103
104%_defconfig: $(obj)/conf
105	$(Q)$< --defconfig=arch/$(SRCARCH)/configs/$@ $(Kconfig)
106
107configfiles=$(wildcard $(srctree)/kernel/configs/$(1).config $(srctree)/arch/$(SRCARCH)/configs/$(1).config)
108
109define mergeconfig
110$(if $(wildcard $(objtree)/.config),, $(error You need an existing .config for this target))
111$(if $(call configfiles,$(1)),, $(error No configuration exists for this target on this architecture))
112$(Q)$(CONFIG_SHELL) $(srctree)/scripts/kconfig/merge_config.sh -m -O $(objtree) $(objtree)/.config $(call configfiles,$(1))
113$(Q)yes "" | $(MAKE) -f $(srctree)/Makefile oldconfig
114endef
115
116PHONY += kvmconfig
117kvmconfig:
118	$(call mergeconfig,kvm_guest)
119
120# Help text used by make help
121help:
122	@echo  '  config	  - Update current config utilising a line-oriented program'
123	@echo  '  nconfig         - Update current config utilising a ncurses menu based program'
124	@echo  '  menuconfig	  - Update current config utilising a menu based program'
125	@echo  '  xconfig	  - Update current config utilising a QT based front-end'
126	@echo  '  gconfig	  - Update current config utilising a GTK based front-end'
127	@echo  '  oldconfig	  - Update current config utilising a provided .config as base'
128	@echo  '  localmodconfig  - Update current config disabling modules not loaded'
129	@echo  '  localyesconfig  - Update current config converting local mods to core'
130	@echo  '  silentoldconfig - Same as oldconfig, but quietly, additionally update deps'
131	@echo  '  defconfig	  - New config with default from ARCH supplied defconfig'
132	@echo  '  savedefconfig   - Save current config as ./defconfig (minimal config)'
133	@echo  '  allnoconfig	  - New config where all options are answered with no'
134	@echo  '  allyesconfig	  - New config where all options are accepted with yes'
135	@echo  '  allmodconfig	  - New config selecting modules when possible'
136	@echo  '  alldefconfig    - New config with all symbols set to default'
137	@echo  '  randconfig	  - New config with random answer to all options'
138	@echo  '  listnewconfig   - List new options'
139	@echo  '  olddefconfig	  - Same as silentoldconfig but sets new symbols to their default value'
140	@echo  '  kvmconfig	  - Enable additional options for guest kernel support'
141
142# lxdialog stuff
143check-lxdialog  := $(srctree)/$(src)/lxdialog/check-lxdialog.sh
144
145# Use recursively expanded variables so we do not call gcc unless
146# we really need to do so. (Do not call gcc as part of make mrproper)
147HOST_EXTRACFLAGS += $(shell $(CONFIG_SHELL) $(check-lxdialog) -ccflags) \
148                    -DLOCALE
149
150# ===========================================================================
151# Shared Makefile for the various kconfig executables:
152# conf:	  Used for defconfig, oldconfig and related targets
153# nconf:  Used for the nconfig target.
154#         Utilizes ncurses
155# mconf:  Used for the menuconfig target
156#         Utilizes the lxdialog package
157# qconf:  Used for the xconfig target
158#         Based on QT which needs to be installed to compile it
159# gconf:  Used for the gconfig target
160#         Based on GTK which needs to be installed to compile it
161# object files used by all kconfig flavours
162
163lxdialog := lxdialog/checklist.o lxdialog/util.o lxdialog/inputbox.o
164lxdialog += lxdialog/textbox.o lxdialog/yesno.o lxdialog/menubox.o
165
166conf-objs	:= conf.o  zconf.tab.o
167mconf-objs     := mconf.o zconf.tab.o $(lxdialog)
168nconf-objs     := nconf.o zconf.tab.o nconf.gui.o
169kxgettext-objs	:= kxgettext.o zconf.tab.o
170qconf-cxxobjs	:= qconf.o
171qconf-objs	:= zconf.tab.o
172gconf-objs	:= gconf.o zconf.tab.o
173
174hostprogs-y := conf
175
176ifeq ($(MAKECMDGOALS),nconfig)
177	hostprogs-y += nconf
178endif
179
180ifeq ($(MAKECMDGOALS),menuconfig)
181	hostprogs-y += mconf
182endif
183
184ifeq ($(MAKECMDGOALS),update-po-config)
185	hostprogs-y += kxgettext
186endif
187
188ifeq ($(MAKECMDGOALS),xconfig)
189	qconf-target := 1
190endif
191ifeq ($(MAKECMDGOALS),gconfig)
192	gconf-target := 1
193endif
194
195
196ifeq ($(qconf-target),1)
197	hostprogs-y += qconf
198endif
199
200ifeq ($(gconf-target),1)
201	hostprogs-y += gconf
202endif
203
204clean-files	:= qconf.moc .tmp_qtcheck .tmp_gtkcheck
205clean-files	+= zconf.tab.c zconf.lex.c zconf.hash.c gconf.glade.h
206clean-files     += mconf qconf gconf nconf
207clean-files     += config.pot linux.pot
208
209# Check that we have the required ncurses stuff installed for lxdialog (menuconfig)
210PHONY += $(obj)/dochecklxdialog
211$(addprefix $(obj)/,$(lxdialog)): $(obj)/dochecklxdialog
212$(obj)/dochecklxdialog:
213	$(Q)$(CONFIG_SHELL) $(check-lxdialog) -check $(HOSTCC) $(HOST_EXTRACFLAGS) $(HOSTLOADLIBES_mconf)
214
215always := dochecklxdialog
216
217# Add environment specific flags
218HOST_EXTRACFLAGS += $(shell $(CONFIG_SHELL) $(srctree)/$(src)/check.sh $(HOSTCC) $(HOSTCFLAGS))
219
220# generated files seem to need this to find local include files
221HOSTCFLAGS_zconf.lex.o	:= -I$(src)
222HOSTCFLAGS_zconf.tab.o	:= -I$(src)
223
224LEX_PREFIX_zconf	:= zconf
225YACC_PREFIX_zconf	:= zconf
226
227HOSTLOADLIBES_qconf	= $(KC_QT_LIBS)
228HOSTCXXFLAGS_qconf.o	= $(KC_QT_CFLAGS)
229
230HOSTLOADLIBES_gconf	= `pkg-config --libs gtk+-2.0 gmodule-2.0 libglade-2.0`
231HOSTCFLAGS_gconf.o	= `pkg-config --cflags gtk+-2.0 gmodule-2.0 libglade-2.0` \
232                          -Wno-missing-prototypes
233
234HOSTLOADLIBES_mconf   = $(shell $(CONFIG_SHELL) $(check-lxdialog) -ldflags $(HOSTCC))
235
236HOSTLOADLIBES_nconf	= $(shell \
237				pkg-config --libs menu panel ncurses 2>/dev/null \
238				|| echo "-lmenu -lpanel -lncurses"  )
239$(obj)/qconf.o: $(obj)/.tmp_qtcheck
240
241ifeq ($(qconf-target),1)
242$(obj)/.tmp_qtcheck: $(src)/Makefile
243-include $(obj)/.tmp_qtcheck
244
245# QT needs some extra effort...
246$(obj)/.tmp_qtcheck:
247	@set -e; echo "  CHECK   qt"; dir=""; pkg=""; \
248	if ! pkg-config --exists QtCore 2> /dev/null; then \
249	    echo "* Unable to find the QT4 tool qmake. Trying to use QT3"; \
250	    pkg-config --exists qt 2> /dev/null && pkg=qt; \
251	    pkg-config --exists qt-mt 2> /dev/null && pkg=qt-mt; \
252	    if [ -n "$$pkg" ]; then \
253	      cflags="\$$(shell pkg-config $$pkg --cflags)"; \
254	      libs="\$$(shell pkg-config $$pkg --libs)"; \
255	      moc="\$$(shell pkg-config $$pkg --variable=prefix)/bin/moc"; \
256	      dir="$$(pkg-config $$pkg --variable=prefix)"; \
257	    else \
258	      for d in $$QTDIR /usr/share/qt* /usr/lib/qt*; do \
259	        if [ -f $$d/include/qconfig.h ]; then dir=$$d; break; fi; \
260	      done; \
261	      if [ -z "$$dir" ]; then \
262	        echo >&2 "*"; \
263	        echo >&2 "* Unable to find any QT installation. Please make sure that"; \
264	        echo >&2 "* the QT4 or QT3 development package is correctly installed and"; \
265	        echo >&2 "* either qmake can be found or install pkg-config or set"; \
266	        echo >&2 "* the QTDIR environment variable to the correct location."; \
267	        echo >&2 "*"; \
268	        false; \
269	      fi; \
270	      libpath=$$dir/lib; lib=qt; osdir=""; \
271	      $(HOSTCXX) -print-multi-os-directory > /dev/null 2>&1 && \
272	        osdir=x$$($(HOSTCXX) -print-multi-os-directory); \
273	      test -d $$libpath/$$osdir && libpath=$$libpath/$$osdir; \
274	      test -f $$libpath/libqt-mt.so && lib=qt-mt; \
275	      cflags="-I$$dir/include"; \
276	      libs="-L$$libpath -Wl,-rpath,$$libpath -l$$lib"; \
277	      moc="$$dir/bin/moc"; \
278	    fi; \
279	    if [ ! -x $$dir/bin/moc -a -x /usr/bin/moc ]; then \
280	      echo "*"; \
281	      echo "* Unable to find $$dir/bin/moc, using /usr/bin/moc instead."; \
282	      echo "*"; \
283	      moc="/usr/bin/moc"; \
284	    fi; \
285	else \
286	  cflags="\$$(shell pkg-config QtCore QtGui Qt3Support --cflags)"; \
287	  libs="\$$(shell pkg-config QtCore QtGui Qt3Support --libs)"; \
288	  moc="\$$(shell pkg-config QtCore --variable=moc_location)"; \
289	  [ -n "$$moc" ] || moc="\$$(shell pkg-config QtCore --variable=prefix)/bin/moc"; \
290	fi; \
291	echo "KC_QT_CFLAGS=$$cflags" > $@; \
292	echo "KC_QT_LIBS=$$libs" >> $@; \
293	echo "KC_QT_MOC=$$moc" >> $@
294endif
295
296$(obj)/gconf.o: $(obj)/.tmp_gtkcheck
297
298ifeq ($(gconf-target),1)
299-include $(obj)/.tmp_gtkcheck
300
301# GTK needs some extra effort, too...
302$(obj)/.tmp_gtkcheck:
303	@if `pkg-config --exists gtk+-2.0 gmodule-2.0 libglade-2.0`; then		\
304		if `pkg-config --atleast-version=2.0.0 gtk+-2.0`; then			\
305			touch $@;								\
306		else									\
307			echo >&2 "*"; 							\
308			echo >&2 "* GTK+ is present but version >= 2.0.0 is required.";	\
309			echo >&2 "*";							\
310			false;								\
311		fi									\
312	else										\
313		echo >&2 "*"; 								\
314		echo >&2 "* Unable to find the GTK+ installation. Please make sure that"; 	\
315		echo >&2 "* the GTK+ 2.0 development package is correctly installed..."; 	\
316		echo >&2 "* You need gtk+-2.0, glib-2.0 and libglade-2.0."; 		\
317		echo >&2 "*"; 								\
318		false;									\
319	fi
320endif
321
322$(obj)/zconf.tab.o: $(obj)/zconf.lex.c $(obj)/zconf.hash.c
323
324$(obj)/qconf.o: $(obj)/qconf.moc
325
326quiet_cmd_moc = MOC     $@
327      cmd_moc = $(KC_QT_MOC) -i $< -o $@
328
329$(obj)/%.moc: $(src)/%.h $(obj)/.tmp_qtcheck
330	$(call cmd,moc)
331
332# Extract gconf menu items for I18N support
333$(obj)/gconf.glade.h: $(obj)/gconf.glade
334	$(Q)intltool-extract --type=gettext/glade --srcdir=$(srctree) \
335	$(obj)/gconf.glade
336